package com.jiuqi.sql.impl;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/* loaded from: com_jiuqi_sql_impl.jar:com/jiuqi/sql/impl/DBaseFieldHeader.class */
public class DBaseFieldHeader {
    public static final int headLength = 50;
    String fieldName;
    char dataType;
    int fieldLength;
    byte scale;
    long incValue;
    byte[] reserved2 = new byte[8];
    byte[] reserved3 = new byte[2];

    public void readFromStream(InputStream stream) throws IOException {
        this.fieldName = RW.readString(stream, 32).trim();
        this.dataType = (char) stream.read();
        this.fieldLength = RW.readWord(stream);
        this.scale = RW.read(stream);
        stream.read(this.reserved2);
        this.incValue = RW.readDWord(stream);
        stream.read(this.reserved3);
    }

    public void writeToStream(OutputStream stream) throws IOException {
        RW.writeString(stream, this.fieldName.trim(), 32);
        stream.write(this.dataType);
        RW.writeWord(stream, this.fieldLength);
        RW.write(stream, this.scale);
        stream.write(this.reserved2);
        RW.writeDWord(stream, this.incValue);
        stream.write(this.reserved3);
    }

    public int getFieldType() {
        int result = 0;
        switch (this.dataType) {
            case '$':
            case '%':
            case 'O':
                result = 3;
                break;
            case '@':
            case 'D':
            case 'T':
                result = 2;
                break;
            case 'C':
            case 'F':
            case 'W':
                result = 6;
                break;
            case 'I':
                result = 5;
                break;
            case 'L':
                result = 1;
                break;
            case 'Z':
                result = 8;
                break;
        }
        return result;
    }

    public void setDataType(int type) {
        switch (type) {
            case 0:
                this.dataType = 'U';
                return;
            case 1:
                this.dataType = 'L';
                return;
            case 2:
                this.dataType = '@';
                return;
            case 3:
                this.dataType = 'O';
                return;
            case 4:
            case 7:
            default:
                return;
            case 5:
                this.dataType = 'I';
                return;
            case 6:
                this.dataType = 'C';
                return;
            case 8:
                this.dataType = 'Z';
                return;
        }
    }

    public String toString() {
        StringBuffer result = new StringBuffer(super.toString());
        result.append(", FieldName:");
        result.append(this.fieldName);
        result.append(", dataType:");
        result.append(this.dataType);
        result.append(", fieldLength:");
        result.append(this.fieldLength);
        result.append(", scale:");
        result.append((int) this.scale);
        result.append(", incValue:");
        result.append(this.incValue);
        return result.toString();
    }

    public static void main(String[] args) {
    }
}
